## 前言

### 1. 简介

Spring R7模板是基于iBiz平台（模型）提供的一套基于微服务架构的解决方案。

### 2. 开发环境要求

- IDE，例如Eclipse或者idea
- JDK1.8+
- GIT
- MAVEN

### 3. 开发技术要求

对`Spring Cloud`、`Spring Boot`等主流技术有一定了解或者熟练掌握。

### 4. 主要技术

- 微服务组件：Spring Cloud Alibaba (2.1.1.RELEASE) 
- ORM：Mybatis Plus (3.0.6)
- 大数据：Spring Data MongoDB（2.2.1.RELEASE）
- 工作流：Activiti （7.1.0.M2）
- 权限：Spring Security (2.1.1.RELEASE)  

## 快速上手

### 1. 开发环境准备

- 安装jdk1.8+
- 安装Eclipse或者idea
- 安装maven
- 安装git

### 2. 导入项目

git从仓库获取代码。

命令参考如下：

```shell
$ git clone -b <指定分支> https://<用户名>:<密码>@<host>:<端口>/<git群组>/<git仓库>
```

也可以使用TortoiseGit或者IDE自带的GIT功能。

### 3. 必要依赖下载

导入项目完成后，使用maven下载必要的依赖包。

### 4. 修改相关配置

理论上，项目获取下来是可以直接运行的。而实际情况下，如果需要变更例如启动端口、Nacos注册地址等等依赖环境内容，则需要手动变更。

### 5. 运行

项目分为2部分启动内容，服务启动（boot目录）以及应用启动（app目录），具体参见详细代码。

## 代码结构展示

![dir](readme_img/dir.png)

### 更新日志

 每个版本的详细更改都记录在发行说明中。

### 如何贡献

如果你希望参与贡献，欢迎 [Pull Request](http://demo.ibizlab.cn/ibiz_r7/vue_r7/issues/new)，或通过自助服务群给我们报告 Bug。

强烈推荐阅读 [《提问的智慧》](https://github.com/ryanhanwu/How-To-Ask-Questions-The-Smart-Way)(本指南不提供此项目的实际支持服务！)、[《如何向开源社区提问题》](https://github.com/seajs/seajs/issues/545) 和 [《如何有效地报告 Bug》](https://www.chiark.greenend.org.uk/~sgtatham/bugs-cn.html)、[《如何向开源项目提交无法解答的问题》](https://zhuanlan.zhihu.com/p/25795393)，更好的问题更容易获得帮助。

### 社区互助

1.[iBizLab论坛](https://bbs.ibizlab.cn/)

2.加入钉钉自助服务群（中文）

![dd](readme_img/dd.png)