<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.filter.${de.getCodeName()}SearchContext;

/**
 * 实体[${item.codeName}] 服务对象接口
 */

<#--  标准模式  -->
public interface I${item.codeName}Service{
    <#assign keyfield=item.getKeyPSDEField()>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if (deaction.getActionType()=='USERCUSTOM')  && (!deaction.codeName?lower_case?contains("major")) ><#comment>Get与自定义行为返回DoMain不发带major</#comment>
     ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.getActionType()=='DELOGIC'>
     ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.codeName == 'Get'>
     ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) ;
     ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.codeName == "Create">
     boolean ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.codeName == "Update">
     boolean ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.codeName == "Remove">
     boolean ${srfmethodname(deaction.getCodeName())}(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) ;
            <#elseif deaction.codeName == "Save">
     boolean ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.codeName == "GetDraft">
     ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.codeName == "CheckKey">
     boolean ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            <#elseif deaction.codeName == "CreateBatch">
     void ${srfmethodname(deaction.getCodeName())}(List<${item.codeName}> ${item.codeName?lower_case}s) ;
            <#elseif deaction.codeName == "UpdateBatch">
     void ${srfmethodname(deaction.getCodeName())}(List<${item.codeName}> ${item.codeName?lower_case}s) ;
            <#elseif deaction.codeName == "RemoveBatch">
     void ${srfmethodname(deaction.getCodeName())}(List<${item.codeName}> ${item.codeName?lower_case}s) ;
            <#else>
     ${item.codeName} ${srfmethodname(deaction.getCodeName())}(${item.codeName} ${item.codeName?lower_case}) ;
            </#if>
        </#list>
    </#if>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    <#--
    public List<${item.codeName}> list${dedataset.getCodeName()}(${item.codeName}SearchFilter filter) {
        return i${de.codeName?lower_case}Storage.list${dedataset.getCodeName()}(filter);
    }
    -->

    /**
     * 查询集合 ${dedataset.getLogicName()}
     */
     Page<${item.codeName}> search${dedataset.getCodeName()}(${item.codeName}SearchContext context) ;
        </#list>
    </#if>

    <#if de.getMinorPSDERs()??>
    <#list de.getMinorPSDERs() as der>
    /**
     * 根据${der.getMajorPSDataEntity().getLogicName()}查询
     */
     Page<${de.getCodeName()}> selectBy${der.getCodeName()}(${srfjavatype(der.getMajorPSDataEntity().getKeyPSDEField().stdDataType)} ${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case}) ;
     List<${de.getCodeName()}> selectBy${der.getCodeName()}2(${srfjavatype(der.getMajorPSDataEntity().getKeyPSDEField().stdDataType)} ${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case});

    </#list>
    </#if>
    <#--  List<${item.codeName}> listByMapTable(Map<String, Object> map);  -->
}
