<#ibiztemplate>
TARGET=PSDATAENTITY
</#ibiztemplate>
package ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
<#if item.isEnableAPIStorage() && item.getPSSubSysServiceAPI()?? && item.getPSSubSysServiceAPIDE()??>
import ${pub.getPKGCodeName()}.core.client.model.I${item.getPSSubSysServiceAPIDE().getCodeName()};
</#if>
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.filter.${de.getCodeName()}SearchContext;
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.I${de.getCodeName()}Service;
<#if item.getAllPSDELogics()??>
<#list item.getAllPSDELogics() as logic>
import ${pub.getPKGCodeName()}.core.${item.getPSSystemModule().getCodeName()?lower_case}.service.logic.I${de.getCodeName()}${logic.getCodeName()}Logic;
</#list>
</#if>
import org.springframework.beans.factory.annotation.Autowired;
import ${pub.getPKGCodeName()}.util.SearchResult;

/**
 * 实体[${item.getCodeName()}] 服务对象接口实现
 */
@Service
public class ${item.getCodeName()}ServiceImpl implements I${de.getCodeName()}Service {

    <#--  存储  -->
    <#--  @Resource(name="<#if de.getStorageMode()==1>sql<#elseif de.getStorageMode()==2>nosql<#elseif de.getStorageMode()==4>client</#if>_${de.getCodeName()}Repository")  -->
    <#if de.getStorageMode()==1 || de.getStorageMode()==2>
    @Autowired
    ${pub.getPKGCodeName()}.core.repository.${de.getCodeName()}Repository ${de.getCodeName()?uncap_first}Repository;

    </#if>
    <#--  api 存储  -->
    <#if item.isEnableAPIStorage() && item.getPSSubSysServiceAPI()?? && item.getPSSubSysServiceAPIDE()??>
    @Autowired
    private ${pub.getPKGCodeName()}.core.client.service.I${item.getPSSubSysServiceAPIDE().getCodeName()}ClientService ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService;

    </#if>


    <#if item.getAllPSDELogics()??>
        <#list item.getAllPSDELogics() as logic>
    @Autowired
    private I${de.getCodeName()}${logic.getCodeName()}Logic ${logic.getCodeName()?lower_case}Logic ;

        </#list>
    </#if>

    <#assign keyfield=item.getKeyPSDEField()>
    <#if item.getAllPSDEActions()??>
        <#list item.getAllPSDEActions() as deaction>
            <#if (deaction.getActionType()=='USERCUSTOM')  && (!deaction.getCodeName()?lower_case?contains("major")) ><#comment>Get与自定义行为返回DoMain不发带major</#comment>
    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        <#if item.isEnableAPIStorage() && deaction.getPSSubSysServiceAPIDEMethod()?? >
        I${item.getPSSubSysServiceAPIDE().getCodeName()} clientModel = this.convert2Model(${item.getCodeName()?lower_case},null);
        ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(clientModel) ;
        this.convert2Domain(clientModel,null);
        </#if>
         return ${item.getCodeName()?lower_case};
    }
            <#elseif deaction.getActionType()=='DELOGIC'>
    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
         ${deaction.getPSDELogic().getCodeName()?lower_case}Logic.execute(${item.getCodeName()?lower_case});
         return ${item.getCodeName()?lower_case} ;
    }
            <#elseif deaction.getCodeName() == 'Get'>
    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) {
        <#if item.isEnableSQLStorage() && item.getAllPSDEDBTables()??>
        <#list item.getAllPSDEDBTables() as detable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${detable.name?uncap_first} = ${de.getCodeName()?uncap_first}Repository.get(${keyfield.getCodeName()?lower_case});
        return ${de.getCodeName()?uncap_first}Repository.convert2Domain(${detable.name?uncap_first},null);
        </#list>
        <#elseif item.isEnableAPIStorage()>
            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        I${item.getPSSubSysServiceAPIDE().getCodeName()} clientModel = ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.createModel();
        clientModel.set${item.getPSSubSysServiceAPIDE().getKeyDEField().getCodeName()?cap_first}(${keyfield.getCodeName()?lower_case});
        ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(clientModel) ;
        return this.convert2Domain(clientModel,null);
            <#else>
        return null ;
            </#if>
        <#elseif item.isEnableNoSQLStorage() && item.getAllPSDEBDTables()??>
        <#list item.getAllPSDEBDTables() as debdtable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${debdtable.getPSSysBDTable().getCodeName()?uncap_first} = ${de.getCodeName()?uncap_first}Repository.get(${keyfield.getCodeName()?lower_case});
        return ${de.getCodeName()?uncap_first}Repository.convert2Domain(${debdtable.getPSSysBDTable().getCodeName()?uncap_first},null);
        </#list>
        <#else>
        return null ;
        </#if>
    }

    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        <#if item.isEnableSQLStorage() && item.getAllPSDEDBTables()??>
        <#list item.getAllPSDEDBTables() as detable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${detable.name?uncap_first} = ${de.getCodeName()?uncap_first}Repository.get(${item.getCodeName()?lower_case}.get${keyfield.getCodeName()?cap_first}());
        ${de.getCodeName()?uncap_first}Repository.convert2Domain(${detable.name?uncap_first},${item.getCodeName()?lower_case});
        return ${item.getCodeName()?lower_case};
        </#list>
        <#elseif item.isEnableAPIStorage()>
            <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        ${item.getCodeName()} ret${item.getCodeName()?lower_case} = this.get(${item.getCodeName()?lower_case}.get${keyfield.getCodeName()?cap_first}()) ;
    	BeanCopier copier=BeanCopier.create(ret${item.getCodeName()?lower_case}.getClass(), ${item.getCodeName()?lower_case}.getClass(), false);
        copier.copy(ret${item.getCodeName()?lower_case}, ${item.getCodeName()?lower_case}, null);
        return ${item.getCodeName()?lower_case} ;
            <#else>
        return null ;
            </#if>
        <#elseif item.isEnableNoSQLStorage() && item.getAllPSDEBDTables()??>
        <#list item.getAllPSDEBDTables() as debdtable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${debdtable.getPSSysBDTable().getCodeName()?uncap_first} = ${de.getCodeName()?uncap_first}Repository.get(${item.getCodeName()?lower_case}.get${keyfield.getCodeName()?cap_first}());
        ${de.getCodeName()?uncap_first}Repository.convert2Domain(${debdtable.getPSSysBDTable().getCodeName()?uncap_first},${item.getCodeName()?lower_case});
        return ${item.getCodeName()?lower_case};
        </#list>
        <#else>
        return null ;
        </#if>
    }

            <#elseif deaction.getCodeName() == "Create">
    @Override
    public boolean ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        boolean bOk = false ;
        <#if item.isEnableSQLStorage() && item.getAllPSDEDBTables()??>
        <#list item.getAllPSDEDBTables() as detable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${detable.name?uncap_first} = ${de.getCodeName()?uncap_first}Repository.convert2PO(${item.getCodeName()?lower_case},null);
        bOk = ${de.getCodeName()?uncap_first}Repository.create(${detable.name?uncap_first});
        ${de.getCodeName()?uncap_first}Repository.convert2Domain(${detable.name?uncap_first},${item.getCodeName()?lower_case});

        </#list>
        <#elseif item.isEnableAPIStorage()>
        <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        I${item.getPSSubSysServiceAPIDE().getCodeName()} clientModel = this.convert2Model(${item.getCodeName()?lower_case},null);
        ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(clientModel) ;
        this.convert2Domain(clientModel,${item.getCodeName()?lower_case});
        bOk = true ;
            <#else>
        bOk = false ;
            </#if>
        <#elseif item.isEnableNoSQLStorage() && item.getAllPSDEBDTables()??>
        <#list item.getAllPSDEBDTables() as debdtable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${debdtable.getPSSysBDTable().getCodeName()?uncap_first} = ${de.getCodeName()?uncap_first}Repository.convert2PO(${item.getCodeName()?lower_case},null);
        bOk = ${de.getCodeName()?uncap_first}Repository.create(${debdtable.getPSSysBDTable().getCodeName()?uncap_first});
        ${de.getCodeName()?uncap_first}Repository.convert2Domain(${debdtable.getPSSysBDTable().getCodeName()?uncap_first},${item.getCodeName()?lower_case});

        </#list>
        </#if>
        return bOk ;
    }

            <#elseif deaction.getCodeName() == "Update">
    @Override
    public boolean ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        boolean bOk = false ;
        <#if item.isEnableSQLStorage() && item.getAllPSDEDBTables()??>
        <#list item.getAllPSDEDBTables() as detable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${detable.name?uncap_first} = ${de.getCodeName()?uncap_first}Repository.convert2PO(${item.getCodeName()?lower_case},null);
        bOk = ${de.getCodeName()?uncap_first}Repository.update(${detable.name?uncap_first});
        ${de.getCodeName()?uncap_first}Repository.convert2Domain(${detable.name?uncap_first},${item.getCodeName()?lower_case}) ;

        </#list>
        <#elseif item.isEnableAPIStorage()>
        <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        I${item.getPSSubSysServiceAPIDE().getCodeName()} clientModel = this.convert2Model(${item.getCodeName()?lower_case},null);
        ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(clientModel) ;
        this.convert2Domain(clientModel,${item.getCodeName()?lower_case}) ;
        bOk = true;
            <#else>
        bOk =false ;
            </#if>
        <#elseif item.isEnableNoSQLStorage() && item.getAllPSDEBDTables()??>
        <#list item.getAllPSDEBDTables() as debdtable>
        ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${debdtable.getPSSysBDTable().getCodeName()?uncap_first} = ${de.getCodeName()?uncap_first}Repository.convert2PO(${item.getCodeName()?lower_case},null);
        bOk = ${de.getCodeName()?uncap_first}Repository.update(${debdtable.getPSSysBDTable().getCodeName()?uncap_first});
        ${de.getCodeName()?uncap_first}Repository.convert2Domain(${debdtable.getPSSysBDTable().getCodeName()?uncap_first},${item.getCodeName()?lower_case}) ;

        </#list>
        </#if>
        return bOk ;
    }

            <#elseif deaction.getCodeName() == "Remove">
    @Override
    public boolean ${srfmethodname(deaction.getCodeName())}(${srfjavatype(keyfield.stdDataType)} ${keyfield.getCodeName()?lower_case}) {
        boolean bOk = false ;
        <#if item.isEnableSQLStorage() && item.getAllPSDEDBTables()??>
        <#list item.getAllPSDEDBTables() as detable>
        bOk = ${de.getCodeName()?uncap_first}Repository.remove(${keyfield.getCodeName()?lower_case});

        </#list>
        <#elseif item.isEnableAPIStorage()>
        <#if deaction.getPSSubSysServiceAPIDEMethod()?? >
        I${item.getPSSubSysServiceAPIDE().getCodeName()} clientModel = ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.createModel();
        clientModel.set${item.getPSSubSysServiceAPIDE().getKeyDEField().getCodeName()?cap_first}(${keyfield.getCodeName()?lower_case});
        ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(clientModel) ;
        bOk = true ;
            <#else>
        bOk = false ;
            </#if>
        <#elseif item.isEnableNoSQLStorage() && item.getAllPSDEBDTables()??>
        <#list item.getAllPSDEBDTables() as debdtable>
        bOk = ${de.getCodeName()?uncap_first}Repository.remove(${keyfield.getCodeName()?lower_case});

        </#list>
        </#if>
        return bOk ;
    }

            <#elseif deaction.getCodeName() == "Save">
    @Override
    public boolean ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        if(${item.getCodeName()?lower_case}.get${keyfield.getCodeName()?cap_first}()==null){
    		return create(${item.getCodeName()?lower_case});
    	}else{
            if(this.get(${item.getCodeName()?lower_case}.get${keyfield.getCodeName()?cap_first}())!=null){
    			return update(${item.getCodeName()?lower_case});
    		}
    		return create(${item.getCodeName()?lower_case});
    	}
    }

            <#elseif deaction.getCodeName() == "GetDraft">
    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        return ${item.getCodeName()?lower_case};
    }

            <#elseif deaction.getCodeName() == "CheckKey">
    @Override
    public boolean ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        return true;
    }
            <#elseif deaction.getCodeName() == "CreateBatch">
    @Override
    public void ${srfmethodname(deaction.getCodeName())}(List<${item.getCodeName()}> ${item.getCodeName()?lower_case}s) {

    }
            <#elseif deaction.getCodeName() == "UpdateBatch">
    @Override
    public void ${srfmethodname(deaction.getCodeName())}(List<${item.getCodeName()}> ${item.getCodeName()?lower_case}s) {

    }
            <#elseif deaction.getCodeName() == "RemoveBatch">
    @Override
    public void ${srfmethodname(deaction.getCodeName())}(List<${item.getCodeName()}> ${item.getCodeName()?lower_case}s) {

    }
            <#else>
    @Override
    public ${item.getCodeName()} ${srfmethodname(deaction.getCodeName())}(${item.getCodeName()} ${item.getCodeName()?lower_case}) {
        <#if item.isEnableAPIStorage() && deaction.getPSSubSysServiceAPIDEMethod()?? >
        I${item.getPSSubSysServiceAPIDE().getCodeName()} clientModel = this.convert2Model(${item.getCodeName()?lower_case},null);
        ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.${deaction.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(clientModel) ;
        this.convert2Domain(clientModel,null);
        </#if>
         return ${item.getCodeName()?lower_case};
    }

            </#if>
        </#list>
    </#if>
    <#if item.getAllPSDEDataSets()??>
        <#list item.getAllPSDEDataSets() as dedataset>
    /**
     * 查询集合 ${dedataset.getLogicName()}
     */
    @Override
    public Page<${item.getCodeName()}> search${dedataset.getCodeName()}(${item.getCodeName()}SearchContext context) {
        <#if item.isEnableSQLStorage() && item.getAllPSDEDBTables()??>
        <#list item.getAllPSDEDBTables() as detable>
        List<${item.getCodeName()}> list = new ArrayList<${item.getCodeName()}>();
        Page<${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()}> ${detable.name?uncap_first}s = ${de.getCodeName()?uncap_first}Repository.search${dedataset.getCodeName()}(context) ;
        for(${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${detable.name?uncap_first} : ${detable.name?uncap_first}s){
            list.add(${de.getCodeName()?uncap_first}Repository.convert2Domain(${detable.name?uncap_first},null));
        }
        return new PageImpl<${item.getCodeName()}>(list, context.getPageable(), ${detable.name?uncap_first}s.getTotalElements());
        </#list>
        <#elseif item.isEnableAPIStorage()>
        <#if dedataset.getPSSubSysServiceAPIDEMethod()?? >
        List<${item.getCodeName()}> list = new ArrayList<${item.getCodeName()}>();
        Page<${pub.getPKGCodeName()}.core.client.model.I${item.getPSSubSysServiceAPIDE().getCodeName()}> clientModelList = ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.${dedataset.getPSSubSysServiceAPIDEMethod().getCodeName()?uncap_first}(context) ;
        for(${pub.getPKGCodeName()}.core.client.model.I${item.getPSSubSysServiceAPIDE().getCodeName()} clientModel : clientModelList){
            list.add( this.convert2Domain(clientModel,null));
        }
        return new PageImpl<${item.getCodeName()}>(list, context.getPageable(), clientModelList.getTotalElements());
            <#else>
        return null ;
            </#if>
        <#elseif item.isEnableNoSQLStorage() && item.getAllPSDEBDTables()??>
        <#list item.getAllPSDEBDTables() as debdtable>
        List<${item.getCodeName()}> list = new ArrayList<${item.getCodeName()}>();
        Page<${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()}> ${debdtable.getPSSysBDTable().getCodeName()?uncap_first}s = ${de.getCodeName()?uncap_first}Repository.search${dedataset.getCodeName()}(context) ;
        for(${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${debdtable.getPSSysBDTable().getCodeName()?uncap_first} : ${debdtable.getPSSysBDTable().getCodeName()?uncap_first}s){
            list.add(${de.getCodeName()?uncap_first}Repository.convert2Domain(${debdtable.getPSSysBDTable().getCodeName()?uncap_first},null));
        }
        return new PageImpl<${item.getCodeName()}>(list, context.getPageable(), ${debdtable.getPSSysBDTable().getCodeName()?uncap_first}s.getTotalElements());
        </#list>
        <#else>
        return null ;
        </#if>
    }

        </#list>
    </#if>

    <#if de.getMinorPSDERs()??>
    <#list de.getMinorPSDERs() as der>
    /**
     * 根据${der.getMajorPSDataEntity().getLogicName()}查询
     */
    @Override
    public Page<${de.getCodeName()}> selectBy${der.getCodeName()}(${srfjavatype(der.getMajorPSDataEntity().getKeyPSDEField().stdDataType)} ${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case} ){
        <#if item.isEnableSQLStorage()>
        <#list de.getAllPSDEDBTables() as detable>
        <#if detable.getTableType() == 'MAIN' >
        ${de.getCodeName()}SearchContext context = new ${de.getCodeName()}SearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case})){
            ${pub.getPKGCodeName()}.util.SearchFieldFilter fieldFilter=new ${pub.getPKGCodeName()}.util.SearchFieldFilter();
            fieldFilter.setParam("${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case}");
            fieldFilter.setCondition(${pub.getPKGCodeName()}.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case});
            context.getCondition().add(fieldFilter);
        }
        List<${de.getCodeName()}> list = new ArrayList<${de.getCodeName()}>();
        Page<${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()}> ${detable.name?uncap_first}s = ${de.getCodeName()?uncap_first}Repository.searchDefault(context) ;
        for(${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${detable.name?uncap_first} : ${detable.name?uncap_first}s){
            list.add(${de.getCodeName()?uncap_first}Repository.convert2Domain(${detable.name?uncap_first},null));
        }
        return new PageImpl<${item.getCodeName()}>(list, context.getPageable(), ${detable.name?uncap_first}s.getTotalElements());
        </#if>
        </#list>
        <#elseif item.isEnableAPIStorage()>
        return null ;
        <#elseif item.isEnableNoSQLStorage()>
        return null ;
        <#else>
        return null ;
        </#if>
    }

    /**
     * 根据${der.getMajorPSDataEntity().getLogicName()}查询
     */
    @Override
    public List<${de.getCodeName()}> selectBy${der.getCodeName()}2(${srfjavatype(der.getMajorPSDataEntity().getKeyPSDEField().stdDataType)} ${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case} ){

        <#if item.isEnableSQLStorage()>
        <#list de.getAllPSDEDBTables() as detable>
        <#if detable.getTableType() == 'MAIN' >
        ${de.getCodeName()}SearchContext context = new ${de.getCodeName()}SearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case})){
            ${pub.getPKGCodeName()}.util.SearchFieldFilter fieldFilter=new ${pub.getPKGCodeName()}.util.SearchFieldFilter();
            fieldFilter.setParam("${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case}");
            fieldFilter.setCondition(${pub.getPKGCodeName()}.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(${der.getMajorPSDataEntity().getKeyPSDEField().getCodeName()?lower_case});
            context.getCondition().add(fieldFilter);
        }
        List<${de.getCodeName()}> list = new ArrayList<${de.getCodeName()}>();
        Page<${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()}> ${detable.name?uncap_first}s = ${de.getCodeName()?uncap_first}Repository.searchDefault(context) ;
        for(${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()} ${detable.name?uncap_first} : ${detable.name?uncap_first}s){
            list.add(${de.getCodeName()?uncap_first}Repository.convert2Domain(${detable.name?uncap_first},null));
        }
        return list;
        </#if>
        </#list>
        <#elseif item.isEnableAPIStorage()>
        return null ;
        <#elseif item.isEnableNoSQLStorage()>
        return null ;
        <#else>
        return null ;
        </#if>
    }
    </#list>
    </#if>


    <#if item.isEnableAPIStorage() && item.getPSSubSysServiceAPI()?? && item.getPSSubSysServiceAPIDE()??>
    public I${item.getPSSubSysServiceAPIDE().getCodeName()} convert2Model(${de.getCodeName()} domain , I${item.getPSSubSysServiceAPIDE().getCodeName()} model) {
        if(domain == null)
            return model ;
        if(model==null){
            model = ${item.getPSSubSysServiceAPIDE().getCodeName()?uncap_first}ClientService.createModel() ;
        }

        <#list item.getPSDEFields() as defield>
        <#if defield.getPSSubSysServiceAPIDEField()??>
        <#assign apidef=defield.getPSSubSysServiceAPIDEField()>
         if(domain.get${defield.getCodeName()?cap_first}DirtyFlag())
            model.set${apidef.getCodeName()?cap_first}(domain.get${defield.getCodeName()?cap_first}());
        </#if>
        </#list>
        <#--  BeanCopier copier=BeanCopier.create(domain.getClass(), model.getClass(), false);
        copier.copy(domain, model, null);  -->
        return model ;
    }

    public ${de.getCodeName()} convert2Domain( I${item.getPSSubSysServiceAPIDE().getCodeName()} model ,${de.getCodeName()} domain) {
        if(model == null)
            return domain ;
        if(domain == null){
            domain = new ${de.getCodeName()}();
        }

        <#list item.getPSDEFields() as defield>
        <#if defield.getPSSubSysServiceAPIDEField()??>
        <#assign apidef=defield.getPSSubSysServiceAPIDEField()>
        if(model.get${apidef.getCodeName()?cap_first}DirtyFlag())
            domain.set${defield.getCodeName()?cap_first}(model.get${apidef.getCodeName()?cap_first}());
        </#if>
        </#list>
        <#--  BeanCopier copier=BeanCopier.create(model.getClass(), domain.getClass(), false);
        copier.copy(model, domain, null);  -->
        return domain ;
    }
    </#if>

}
