<#ibiztemplate>
TARGET=PSDEFVALUERULE
</#ibiztemplate>
<#--<#if ((pub.getUserTag4())!'')=='nancy'>-->
package ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().codeName?lower_case}.valuerule.validator.${de.codeName?lower_case};

import lombok.extern.slf4j.Slf4j;
import ${pub.getPKGCodeName()}.util.valuerule.DefaultValueRule;
import ${pub.getPKGCodeName()}.util.valuerule.VRCondition;
import ${pub.getPKGCodeName()}.util.valuerule.condition.*;
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().codeName?lower_case}.valuerule.anno.${de.codeName?lower_case}.${de.codeName}${item.getPSDEField().codeName?cap_first}${item.codeName};
import org.springframework.stereotype.Component;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;


    <#comment>属性值对应的java类</#comment>
    <#assign defieldType = srfjavatype(item.getPSDEField().stdDataType)>
/**
 * 值规则注解解析类
 * 实体：${de.codeName}
 * 属性：${item.getPSDEField().codeName}
 * 值规则：${item.codeName}
    <#assign message = item.getName()>
    <#if item.getRuleInfo()?? && item.getRuleInfo() !='()'>
        <#assign message = item.getRuleInfo()>
    </#if>
 * 值规则信息：${message}
 */
@Slf4j
@Component("${de.codeName}${item.getPSDEField().codeName?cap_first}${item.codeName}Validator")
public class ${de.codeName}${item.getPSDEField().codeName?cap_first}${item.codeName}Validator implements ConstraintValidator<${de.codeName}${item.getPSDEField().codeName?cap_first}${item.codeName}, ${defieldType}>,Validator {
    private static final String MESSAGE = "值规则校验失败：【${message}】";

    @Override
    public boolean isValid(${defieldType} value, ConstraintValidatorContext context) {
        boolean isValid = doValidate(value);
        if(!isValid) {
            context.disableDefaultConstraintViolation();
            context.buildConstraintViolationWithTemplate(MESSAGE)
                    .addConstraintViolation();
        }
        return doValidate(value);
    }

    @Override
    public boolean supports(Class<?> aClass) {
    <#comment>TODO 细化……</#comment>
        return true;
    }

    @Override
    public void validate(Object o, Errors errors) {
        if( o!=null && supports(o.getClass())){
            if (!doValidate((${defieldType}) o)){
                errors.reject(MESSAGE);
            }
        }
    }

    public boolean doValidate(${defieldType} value) {
<#if item.codeName =='Default'>
        DefaultValueRule<${defieldType}> valueRule = new DefaultValueRule<>("默认值规则",MESSAGE,"${item.getPSDEField().codeName}",value)
                //字符串长度，重复检查模式，重复值范围，基础值规则，是否递归检查。
                .init(${item.getPSDEField().getStringLength()?c},"${item.getPSDEField().getDupCheckMode()}",null,null,${item.getPSDEField().isCheckRecursion()?c});
        return valueRule.isValid();
<#else>
        VRGroupCondition<${defieldType}> groupCondition =
        <@generateRGroupCondition item.getPSDEFVRGroupCondition() />
                ;
       return groupCondition.isValid();
</#if>
    }
}

    <#comment>组条件代码生成 start</#comment>
    <#macro generateRGroupCondition vrCondition>
                new VRGroupCondition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value)
                    .init(${(vrCondition.getCondOp()=='AND')?c})
        <#if vrCondition.getPSDEFVRConditions()??>
            <#list vrCondition.getPSDEFVRConditions() as vrCondition>

                <#assign conditionType = vrCondition.getCondType()>
                <#if conditionType == 'SIMPLE'>
                    <#comment>常规条件(Simple)</#comment>
                    .add(new VRSimpleCondition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value)
                                        //操作类型，参数类型，参数值
                            .init(VRSimpleCondition.OpType.${vrCondition.getPSDBValueOPId()},"${vrCondition.getParamType()!""}","${vrCondition.getParamValue()!""}"))
                <#elseif conditionType == 'REGEX'>
                    <#comment>正则条件（REGEX）</#comment>
                    .add(new VRRegExSingleCondition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value)
                                        //正则表达式
                            .init("${vrCondition.getRegExCode()?replace("\\","\\\\")?replace("\"","\\\"")}"))

                <#elseif conditionType == 'VALUERANGE2'>
                    <#comment>数值范围 (VALUERANGE2) </#comment>
                                        //最小值，最大值，是否包含最小值，是否包含最大值
                    .add(new VRValueRange2Condition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value)
                            .init("${vrCondition.getMinValue()!""}","${vrCondition.getMaxValue()!""}",${vrCondition.isIncludeMinValue()?c},${vrCondition.isIncludeMaxValue()?c}))
                <#elseif conditionType == 'VALUERANGE3'>
                    <#comment>数值范围（VALUERANGE3）值清单 </#comment>
                    .add(new VRValueRange3Condition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value)
                    <#assign listString ="">
                    <#if vrCondition.getValueRanges()??>
                        <#list vrCondition.getValueRanges() as valueRange>
                            <#assign listString = listString + "\""+ valueRange +"\"">
                            <#if valueRange_has_next>
                                <#assign listString = listString + ", ">
                            </#if>
                        </#list>
                    </#if>
                            //值清单
                            .init(${listString}))

                <#elseif conditionType == 'STRINGLENGTH'>
                    <#comment>字符长度（STRINGLENGTH） </#comment>
                    .add(new VRStringLengthCondition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value)
                                        //最小长度，最大长度，是否包含最小值，是否包含最大值。
                            .init(${vrCondition.getMinValue()!"null"},${vrCondition.getMaxValue()!"null"},${vrCondition.isIncludeMinValue()?c},${vrCondition.isIncludeMaxValue()?c}))
                <#elseif conditionType == 'SYSVALUERULE'>
                    <#comment>系统值规则（SYSVALUERULE） </#comment>
                    .add(new VRSysValueRuleCondition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value))
                <#elseif conditionType == 'VALUERANGE'>
                    <#comment>数据集范围（VALUERANGE）start</#comment>
                    .add(new VRValueRangeCondition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}", value)
                    <#assign  majorField = ""/>
                    <#assign  exField = "" />
                    <#if vrCondition.getMajorPSDataEntity()?? >
                        <#assign majorField = ''>
                        <#if vrCondition.getExtMajorPSDEField()??>
                        <#assign majorField = vrCondition.getExtMajorPSDEField().codeName>
                        </#if>
                    </#if>
                    <#if vrCondition.getExtMajorPSDEField()??>
                        <#assign exField = vrCondition.getExtMajorPSDEField().codeName>
                    </#if>
                    <#assign majorEntity = vrCondition.getMajorPSDataEntity()/>
                            //属性名，当前实体，数据集，数据集实体，数据集属性附加，当前实体附加属性
                            .init("${item.getPSDEField().codeName}", ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().codeName?lower_case}.domain.${de.codeName}.class,"${vrCondition.getMajorPSDEDataSet().getName()?lower_case?cap_first}",
                                     ${pub.getPKGCodeName()}.core.${majorEntity.getPSSystemModule().codeName?lower_case}.domain.${majorEntity.codeName}.class," ${majorField?lower_case}","${exField?lower_case}"))
                <#elseif conditionType == 'VALUERECURSION'>
                    .add(new VRValueRecursionCondition<>("${vrCondition.getName()}", ${vrCondition.isNotMode()?c}, "${item.getRuleInfo()!""}",value))
                <#elseif conditionType == 'GROUP'>
                    <#comment>条件组（GROUP） </#comment>
                    .add(
                    <@generateRGroupCondition vrCondition=vrCondition />
                        )
                <#else>
                </#if>

            </#list>
        </#if>
    </#macro>
    <#comment>组条件代码生成 end</#comment>

<#--</#if>-->

