<#ibiztemplate>
TARGET=PSDEDBTABLE
</#ibiztemplate>
package ${pub.getPKGCodeName()}.mybatis.${de.getPSSystemModule().getCodeName()?lower_case};

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;

import ${pub.getPKGCodeName()}.core.repository.${de.getCodeName()}Repository;
import ${pub.getPKGCodeName()}.core.repository.po.${de.getCodeName()};
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.filter.${de.codeName}SearchContext;
import ${pub.getPKGCodeName()}.mybatis.${de.getPSSystemModule().getCodeName()?lower_case}.mapper.${item.name}Mapper;
import ${pub.getPKGCodeName()}.mybatis.${de.getPSSystemModule().getCodeName()?lower_case}.po.${item.name}Impl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import ${pub.getPKGCodeName()}.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[${item.name}] 存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "${de.getCodeName()?lower_case}", value="store" , havingValue = "sql", matchIfMissing = <#if de.getStorageMode()==1>true<#else>false</#if>)
public class ${item.name}RepositoryImpl extends ServiceImpl<${item.name}Mapper, ${item.name}Impl> implements ${de.getCodeName()}Repository {

    @Autowired
    QueryBuilder queryBuilder;

    private boolean isLogicValid = ${de.isLogicValid()?c} ;

    @Autowired
	${item.name}Mapper ${item.name?uncap_first}Mapper;

    public ${de.getCodeName()} createPO(){
        return new ${item.name}Impl();
    }

    public ${de.getCodeName()} get(String key){
        return this.getById(key);
    }

    <#--  public ${item.name} get(${item.name} po){
        ${item.name} result = this.get(po.get${de.getKeyPSDEField().getCodeName()?lower_case?cap_first}());
        if(result!=null){
		    BeanCopier copier=BeanCopier.create(result.getClass(),po.getClass(), false);
		    copier.copy(result,po,null);
    	}
    	return po;
    }  -->

    public boolean create(${de.getCodeName()} po){
        return this.save((${item.name}Impl)po);
    }

    public boolean update(${de.getCodeName()} po){
        return this.updateById((${item.name}Impl)po);
    }

    public boolean remove(String key){
        return this.removeById(key);
    }

<#if de.getAllPSDEDataSets()??>
    <#list de.getAllPSDEDataSets() as dedataset>
    public Page<${de.getCodeName()}> search${dedataset.getCodeName()?cap_first}(${de.codeName}SearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<${de.getCodeName()}> page_datas=${item.name?uncap_first}Mapper.search${dedataset.getCodeName()?cap_first}(page,context,qw);
        List<${de.getCodeName()}> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<${de.getCodeName()}>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    </#list>
</#if>

    public ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()} convert2Domain( ${de.getCodeName()} po ,${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()} domain){
              if(po == null)
                     return domain ;
              if(domain == null){
                     domain = new ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()}();
              }
    <#list de.getAllPSDEFields()  as defield>
        <#if defield.getPSSysDBColumn()??>
            //if(po.get${defield.getCodeName()?cap_first}DirtyFlag())
                domain.set${defield.getCodeName()?cap_first}(po.get${defield.getCodeName()?cap_first}());
        </#if>
    </#list>
              return domain ;
    }

    public ${de.getCodeName()} convert2PO(${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()} domain , ${de.getCodeName()} po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
    <#list de.getAllPSDEFields()  as defield>
        <#if defield.getPSSysDBColumn()??>
        if(domain.get${defield.getCodeName()?cap_first}DirtyFlag())
            po.set${defield.getCodeName()?cap_first}(domain.get${defield.getCodeName()?cap_first}());
        </#if>
    </#list>

        return po ;
    }
}
