<#ibiztemplate>
TARGET=PSDESERVICEAPI
</#ibiztemplate>
package ${pub.getPKGCodeName()}.service.${item.getPSSysServiceAPI().getCodeName()?lower_case}.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
<@addValueRuleImport />
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

/**
 * 服务DTO对象[${item.getCodeName()}DTO]
 */
public class ${item.getCodeName()}DTO implements Serializable {

	private static final long serialVersionUID = 1L;

<#--  服务实体属性相关  -->
<#if item.getPSDEServiceAPIFields()??>
    <#list item.getPSDEServiceAPIFields() as apifield>
        <#comment>值规则注解添加 start</#comment>
        <#--  <#if apifield.getPSDEField().getAllPSDEFValueRules()??>
            <#list apifield.getPSDEField().getAllPSDEFValueRules() as valueRule>
    //@${valueRule.getPSDEField().getDataEntity().codeName}${valueRule.getPSDEField().codeName?cap_first}${valueRule.codeName}(info = "${valueRule.getName()}")
            </#list>
        </#if>  -->
        <#comment>值规则注解添加 end</#comment>
    /**
     * 属性 [${apifield.getName()}]
     *
     */

    <@addValueRuleAnno de.getPSDEField(apifield.getCodeName()) />
    private ${srfjavatype(apifield.getStdDataType())} ${apifield.getCodeName()?cap_first};

    @JsonIgnore
    private boolean ${apifield.getCodeName()?cap_first}DirtyFlag;

    </#list>

    <#list item.getPSDEServiceAPIFields() as apifield>
    /**
     * 获取 [${apifield.getName()}]
     */
    @JsonProperty("${apifield.getCodeName()?lower_case}")
    public ${srfjavatype(apifield.getStdDataType())} get${apifield.getCodeName()?cap_first}(){
        return ${apifield.getCodeName()?cap_first} ;
    }

    /**
     * 设置 [${apifield.getName()}]
     */
    @JsonProperty("${apifield.getCodeName()?lower_case}")
    public void set${apifield.getCodeName()?cap_first}(${srfjavatype(apifield.getStdDataType())}  ${apifield.getCodeName()?uncap_first}){
        this.${apifield.getCodeName()?cap_first} = ${apifield.getCodeName()?uncap_first} ;
        this.${apifield.getCodeName()?cap_first}DirtyFlag = true ;
    }

    /**
     * 获取 [${apifield.getName()}]脏标记
     */
    @JsonIgnore
    public boolean get${apifield.getCodeName()?cap_first}DirtyFlag(){
        return ${apifield.getCodeName()?cap_first}DirtyFlag ;
    }

    </#list>
</#if>

<#comment>true/false暂时为是否导出子数据</#comment>
<#if item.getPSDEServiceAPIRSs()?? >
    <#list item.getPSDEServiceAPIRSs() as apider>
    <#if apider.getMinorPSDEServiceAPI().isNested()>
    <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
    
    <#--  
    <#if apider.getParentFilter()?? >
        <#assign subDTOs = apider.getParentFilter()?uncap_first >
    <#else>
        <#if apider.getPSDER1N()??>
        <#assign subDTOs = apider.getPSDER1N().getCodeName()?uncap_first >
        </#if>
    </#if>  
    -->
    /**
     *  [${apider.getMinorPSDEServiceAPI().getName()}]
     */
	private List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subDTOs} = new ArrayList<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO>();

    public List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> get${subDTOs?cap_first}(){
        return ${subDTOs} ;
    }

    public void set${subDTOs?cap_first}(List <${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subDTOs}){
        this.${subDTOs} = ${subDTOs} ;
    }

    </#if>
    </#list>
</#if>

    public ${de.getCodeName()} toDO() {

        ${de.getCodeName()} srfdomain = new ${de.getCodeName()}();
<#list item.getPSDEServiceAPIFields() as apifield>
    <#if apifield.getPSDEField()??>
    <#assign defield=apifield.getPSDEField()>
        if(get${apifield.getCodeName()?cap_first}DirtyFlag())
            srfdomain.set${defield.getCodeName()?cap_first}(${apifield.getCodeName()?cap_first});
    </#if>
</#list>
        return srfdomain;
    }

    public void fromDO(${de.getCodeName()} srfdomain) {

<#list item.getPSDEServiceAPIFields() as apifield>
    <#if apifield.getPSDEField()??>
    <#assign defield=apifield.getPSDEField()>
        if(srfdomain.get${defield.getCodeName()?cap_first}DirtyFlag())
            this.set${apifield.getCodeName()?cap_first}(srfdomain.get${defield.getCodeName()?cap_first}());
    </#if>
</#list>

    }

    <#--public List<${de.getCodeName()}DTO> fromPOPage(Page<${de.getCodeName()}> poPage)   {-->
    public List<${de.getCodeName()}DTO> fromDOPage(List<${de.getCodeName()}> poPage)   {
        if(poPage == null)
            return null;
        List<${de.getCodeName()}DTO> dtos=new ArrayList<${de.getCodeName()}DTO>();
        <#--for(${de.getCodeName()} po : poPage.getRecords()) {-->
        for(${de.getCodeName()} domain : poPage) {
            ${de.getCodeName()}DTO dto = new ${de.getCodeName()}DTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

<#macro addValueRuleAnno defield>
    <#comment>在属性字段中添加值规则注解</#comment>
    <#--<#if ((pub.getUserTag4())!'')=='nancy'>-->
        <#if defield.getAllPSDEFValueRules()??>
            <#list defield.getAllPSDEFValueRules() as valueRule>
    @${de.codeName}${valueRule.getPSDEField().codeName?cap_first}${valueRule.codeName}(info = "${valueRule.getName()}")
            </#list>
        </#if>
    <#--</#if>-->
</#macro>

<#macro addValueRuleImport >
    <#comment>添加值规则引用</#comment>
    <#--<#if ((pub.getUserTag4())!'')=='nancy'>-->
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().codeName?lower_case}.valuerule.anno.${de.codeName?lower_case}.*;
    <#--</#if>-->
</#macro>
