<#ibiztemplate>
TARGET=PSDESERVICEAPI
</#ibiztemplate>
<#--  SYSAPI为RESTFUL，主从接口（非嵌套）  -->
<#if api.getAPIType() == "RESTFUL" && !item.isNested()>
<#assign pubPkgCodeName = pub.getPKGCodeName()>
<#assign itemCodeName = item.getCodeName()>
<#assign itemCodeNameLC = itemCodeName?lower_case>
<#assign deCodeName = de.getCodeName()>
<#assign deCodeNameLC = deCodeName?lower_case>
<#assign dePKCodeName = de.getKeyPSDEField().getCodeName()>
<#assign dePKCodeNameLC = de.getKeyPSDEField().getCodeName()?lower_case>
<#assign deModelCodeNameLC = de.getPSSystemModule().getCodeName()?lower_case>
<#assign itemSysApiCodeName = item.getPSSysServiceAPI().getCodeName()>
<#assign itemSysApiCodeNameLC = item.getPSSysServiceAPI().getCodeName()?lower_case>
<#assign keyCNLC = "_id">
package ${pubPkgCodeName}.service.${itemSysApiCodeNameLC}.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
<#if de.getStorageMode()==4><#else>import org.springframework.transaction.annotation.Transactional;</#if>
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import ${pubPkgCodeName}.service.${itemSysApiCodeNameLC}.dto.${itemCodeName}DTO;
import ${pubPkgCodeName}.core.${deModelCodeNameLC}.domain.${deCodeName};
import ${pubPkgCodeName}.core.${deModelCodeNameLC}.service.I${deCodeName}Service;
import ${pubPkgCodeName}.util.SearchContext;
import ${pubPkgCodeName}.core.${deModelCodeNameLC}.filter.${deCodeName}SearchContext;
<#if item.getPSDEServiceAPIRSs()??>
  <#list item.getPSDEServiceAPIRSs() as apider>
    <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
    <#assign deapideCN=deapide.getCodeName()>
    <#assign deapideModuleCNLC=deapide.getPSSystemModule().getCodeName()?lower_case>
    <#if apider.getMinorPSDEServiceAPI().isNested()>
import ${pubPkgCodeName}.service.${itemSysApiCodeNameLC}.dto.${deapideCN}DTO;
import ${pubPkgCodeName}.core.${deapideModuleCNLC}.domain.${deapideCN};
import ${pubPkgCodeName}.core.${deapideModuleCNLC}.service.I${deapideCN}Service;
    </#if>
  </#list>
</#if>

@Api(tags = {"${itemCodeName}" })
@RestController
@RequestMapping("")
public class ${itemCodeName}Resource {

    @Autowired
    private I${deCodeName}Service ${deCodeNameLC}Service;

    public I${deCodeName}Service get${deCodeNameLC?cap_first}Service() {
        return this.${deCodeNameLC}Service;
    }

<#--  嵌套服务对象  -->
<#if item.getPSDEServiceAPIRSs()??>
  <#list item.getPSDEServiceAPIRSs() as apider>
    <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
    <#assign deapideCN=deapide.getCodeName()>
    <#assign deapideModuleCNLC=deapide.getPSSystemModule().getCodeName()?lower_case>
    <#if apider.getMinorPSDEServiceAPI().isNested()>
    @Autowired
    private I${deapideCN}Service ${deapideCN?lower_case}Service;

    public I${deapideCN}Service get${deapideCN?lower_case?cap_first}Service() {
        return this.${deapideCN?lower_case}Service;
    }

    </#if>
  </#list>
</#if>
<#--  主接口  start -->
<#if item.isMajor()>
<#assign parentPath = "/" + item.getPSSysServiceAPI().getCodeName()?lower_case  >
<#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
<#assign parentParams = "">
<#assign parentSearchParams = "" >
<#assign parentParams2 = "">
<#assign parentParams3 = "">
<#assign idParams = "">
<#assign idParams2 = "">
<#assign idParams3 = "">
<#assign etParams = "">
<#assign etParamsList = "">
<#assign etParams2 = "">
<#assign etParams3 = "">
<#assign id_etParams = "">
<#assign id_etParams4 = "">
<#assign id_etParams4_batch = "">

<#assign etParams = etParams + "@RequestBody " + itemCodeName + "DTO " + itemCodeNameLC + "dto">
<#assign etParamsList = etParamsList + "@RequestBody List<" + itemCodeName + "DTO> " + itemCodeNameLC + "dtos">
<#assign etParams2 = etParams2 +  itemCodeName + "DTO " + itemCodeNameLC + "dto">
<#assign etParams3 = etParams3 +  itemCodeNameLC + "dto">
<#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().getStdDataType()) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().getStdDataType()) + " " + itemCodeNameLC + keyCNLC >
<#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
<#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().getStdDataType())+" " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + "DTO " + itemCodeNameLC + "dto" >
<#assign id_etParams4 = id_etParams4 + "@RequestBody " + itemCodeName + "DTO " + itemCodeNameLC + "dto" >
<#assign id_etParams4_batch = id_etParams4_batch + "@RequestBody List<" + itemCodeName + "DTO> " + itemCodeNameLC + "dtos" >
<#assign fullPath = parentPath + selfPath>
    <#if item.getPSDEServiceAPIMethods()??>
        <#list item.getPSDEServiceAPIMethods() as apiMethod>
            <#assign reqMtd = apiMethod.getRequestMethod()>
            <#assign statusCode = "">
            <#if reqMtd == "POST" >
                <#assign statusCode = "HttpStatus.CREATED" >
            <#else>
                <#assign statusCode = "HttpStatus.OK" >
            </#if>
            <#if apiMethod.getActionType()=='DEACTION'>
                <#assign deaction = apiMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.POST, value = "${fullPath}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}(${etParams}) {
        ${itemCodeName}DTO dto = new ${itemCodeName}DTO();
        ${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
		${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain);
        dto.fromDO(domain);
                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                            <#if apider.getMinorPSDEServiceAPI().isNested()>
                                <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
		List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
        List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
        if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
            for (${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                ${deapide.getCodeName()?lower_case}Do.set${dePKCodeName?cap_first}(dto.get${dePKCodeName?cap_first}());
                ${deapide.getCodeName()?lower_case}Service.${srfmethodname(deactionCodeName)}(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
            }
        } else {
            ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
        }
        dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);

                            </#if>
                        </#list>
                    </#if>
		return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

                <#elseif deaction.codeName == 'Update'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.PUT, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}(${id_etParams}) {
		${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
        domain.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});
		${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain);
		${itemCodeName}DTO dto = new ${itemCodeName}DTO();
		dto.fromDO(domain);
                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deMinApi = apider.getMinorPSDEServiceAPI()>
                            <#assign deMinApiCN = deMinApi.getCodeName()>
                            <#assign deMinApiCNLC = deMinApi.getCodeName()?lower_case>
                            <#assign deapide=deMinApi.getPSDataEntity()>
                            <#if deMinApi.isNested()>
                                <#assign subDTOs = srfpluralize(deMinApiCN)?lower_case >
		List<${deMinApiCN}DTO> ${deMinApiCNLC}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
		List<${deapide.getCodeName()}> ${deMinApiCNLC}DOs = ${deapide.getCodeName()?lower_case}Service.selectBy${apider.getPSDER1N().getCodeName()}2(${itemCodeNameLC + keyCNLC});
        List<${srfjavatype(deapide.getKeyPSDEField().getStdDataType())}> ${deMinApiCNLC}Ids = new ArrayList<${srfjavatype(deapide.getKeyPSDEField().getStdDataType())}>();
        if (${deMinApiCNLC}DOs != null && !${deMinApiCNLC}DOs.isEmpty()) {
            for (${deapide.getCodeName()} minorDO : ${deMinApiCNLC}DOs) {
                ${deMinApiCNLC}Ids.add(minorDO.get${deapide.getKeyPSDEField().getCodeName()?cap_first}());
            }
        }
        List<${deMinApiCN}DTO> ${deMinApiCNLC}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
        if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
            for (${deMinApiCN}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                ${deapide.getCodeName()?lower_case}Do.set${dePKCodeName?cap_first}(dto.get${dePKCodeName?cap_first}());
                if ( StringUtils.isEmpty( ${deapide.getCodeName()?lower_case}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}()) || (${deMinApiCNLC}Ids != null && !${deMinApiCNLC}Ids.isEmpty() &&  ${deMinApiCNLC}Ids.contains(${deapide.getCodeName()?lower_case}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}()))) {
                    ${deapide.getCodeName()?lower_case}Service.save(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
                } else {
                    ${deapide.getCodeName()?lower_case}Service.remove(${deapide.getCodeName()?lower_case}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}());
                }
            }
        } else {
            ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
        }
        dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);

                            </#if>
                        </#list>
                    </#if>
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

                <#elseif deaction.codeName == 'Get'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.GET, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}(${idParams}) {
        ${itemCodeName}DTO dto = new ${itemCodeName}DTO();
        ${deCodeName} domain =new ${deCodeName}();
        domain.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});
		${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain);
		dto.fromDO(domain);
                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                            <#if apider.getMinorPSDEServiceAPI().isNested()>
                                <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
        Page<${deapide.getCodeName()}> ${deapide.getCodeName()?lower_case?cap_first}Dos = ${deapide.getCodeName()?lower_case}Service.selectBy${apider.getPSDER1N().getCodeName()}(${itemCodeNameLC + keyCNLC});
		if(${deapide.getCodeName()?lower_case?cap_first}Dos != null){
		    List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subDTOs} = new ArrayList<${deapide.getCodeName()}DTO>();
            for (${deapide.getCodeName()} ${deapide.getCodeName()?lower_case?cap_first}Do : ${deapide.getCodeName()?lower_case?cap_first}Dos) {
                ${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dto = new ${apider.getMinorPSDEServiceAPI().getCodeName()}DTO();
                ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case?cap_first}Do);
                ${subDTOs}.add(${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dto);
            }
            dto.set${subDTOs?cap_first}(${subDTOs});
        }
                            </#if>
                        </#list>
                    </#if>
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

                <#elseif deaction.codeName == 'Remove'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.DELETE, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${idParams}) {
        ${itemCodeName}DTO ${itemCodeNameLC}dto = new ${itemCodeName}DTO();
		${deCodeName} domain = new ${deCodeName}();
		${itemCodeNameLC}dto.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});
		domain.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});

                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                            <#if apider.getMinorPSDEServiceAPI().isNested()>
		Map<String, Object> ${deapide.getCodeName()?lower_case?cap_first}Map = new HashMap<String, Object>();
        ${deapide.getCodeName()?lower_case?cap_first}Map.put("${dePKCodeNameLC}",${itemCodeNameLC + keyCNLC});
        Page<${deapide.getCodeName()}> ${deapide.getCodeName()?lower_case?cap_first}Dos = ${deapide.getCodeName()?lower_case}Service.selectBy${apider.getPSDER1N().getCodeName()}(${itemCodeNameLC + keyCNLC});
		if(${deapide.getCodeName()?lower_case?cap_first}Dos != null){
            for (${deapide.getCodeName()} ${deapide.getCodeName()?lower_case?cap_first}Do : ${deapide.getCodeName()?lower_case?cap_first}Dos) {
                ${deapide.getCodeName()?lower_case}Service.${deactionCodeName?lower_case}(${deapide.getCodeName()?lower_case?cap_first}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}());
            }
        }
                            </#if>
                        </#list>
                    </#if>
        Boolean rst = ${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain.get${dePKCodeName?cap_first}());
        if(rst){
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}else{
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}
    }

               <#elseif deaction.codeName == 'CheckKey'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParams}) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

               <#elseif deaction.codeName == 'CreateBatch'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?uncap_first}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${deCodeName}(${etParamsList}) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

               <#elseif deaction.codeName == 'UpdateBatch'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?uncap_first}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParamsList}) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

               <#elseif deaction.codeName == 'RemoveBatch'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParamsList}) {

        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

                <#elseif deaction.codeName == 'Save'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}(${etParams}) {
        ${deCodeName} ${deCodeNameLC} = ${itemCodeNameLC}dto.toDO();
    	Boolean b = ${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(${deCodeNameLC}) ;
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

                <#elseif deaction.getUserTag()?? && deaction.getActionType()?? && deaction.getUserTag() == 'REGIST' && deaction.getActionType() == 'USERCREATE'>
                <#--      注册服务      -->
                    <#if deaction.isBatchAction()>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<List<${itemCodeName}DTO>> ${deactionCodeName?uncap_first}(${id_etParams4_batch}) {
        if (${itemCodeNameLC}dtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<${deCodeName}DTO> ${itemCodeNameLC}dtos2 = new ArrayList<${deCodeName}DTO>();
        for (${itemCodeName}DTO ${itemCodeNameLC}dto : ${itemCodeNameLC}dtos) {
            ${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
            ${deCodeNameLC}Service.save(domain);
            ${itemCodeNameLC}dto.fromDO(domain);
                            <#if item.getPSDEServiceAPIRSs()??>
                                <#list item.getPSDEServiceAPIRSs() as apider>
                                    <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                                    <#if apider.getMinorPSDEServiceAPI().isNested()>
                                        <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
            List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
            List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
            if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
                for (${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                    ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                    ${deapide.getCodeName()?lower_case}Service.save(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
                }
            } else {
                ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
            }
            ${itemCodeNameLC}dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);
                                </#if>
                            </#list>
                        </#if>
            ${itemCodeNameLC}dtos2.add(${itemCodeNameLC}dto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(${itemCodeNameLC}dtos2);
    }

                    <#else>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}(${id_etParams4}) {
        ${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
		${deCodeNameLC}Service.save(domain);
        ${itemCodeNameLC}dto.fromDO(domain);
                        <#if item.getPSDEServiceAPIRSs()??>
                            <#list item.getPSDEServiceAPIRSs() as apider>
                                <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                                <#if apider.getMinorPSDEServiceAPI().isNested()>
                                    <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
		List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
        List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
        if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
            for (${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                ${deapide.getCodeName()?lower_case}Service.save(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
            }
        } else {
            ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
        }
        ${itemCodeNameLC}dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);
                                </#if>
                            </#list>
                        </#if>
		return ResponseEntity.status(HttpStatus.OK).body(${itemCodeNameLC}dto);
    }

                    </#if>
                <#else>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}/${deactionCodeName?lower_case}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}(${id_etParams}) {
        ${deCodeName} ${deCodeNameLC} = ${itemCodeNameLC}dto.toDO();
    	${deCodeNameLC} = ${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(${deCodeNameLC}) ;
    	${itemCodeNameLC}dto.fromDO(${deCodeNameLC});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeNameLC}dto);
    }

                </#if>
            <#elseif apiMethod.getActionType()=='FETCH'>
                <#assign deds = apiMethod.getPSDEDataSet()>
	@ApiOperation(value = "获取${deds.getLogicName()}", tags = {"${itemCodeName}" } ,notes = "获取${deds.getLogicName()}")
    @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
	public ResponseEntity<Page<${itemCodeName}DTO>> fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}</#if>(<#if parentParams!="">${parentParams},</#if>${deCodeName}SearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<${itemCodeName}DTO> list = new ArrayList<${itemCodeName}DTO>();
        ${parentSearchParams}
        Page<${deCodeName}> domains = ${deCodeNameLC}Service.search${deds.getCodeName()}(context) ;
        for(${deCodeName} ${deCodeName?lower_case} : domains.getContent()){
            ${itemCodeName}DTO dto = new ${itemCodeName}DTO();
            dto.fromDO(${deCodeName?lower_case});
            list.add(dto);
        }
	    return ResponseEntity.status(${statusCode}).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}

            </#if>
        </#list>
    </#if>
</#if>
<#--  主接口  end -->

<#--  关系接口  start  -->
<#if item.getPSDEServiceAPIRSPathCount() gt 0>
  <#list 0..1000 as x>
    <#if x gte item.getPSDEServiceAPIRSPathCount()>
      <#break>
    <#else>
      <#list item.getPSDEServiceAPIRSPath(x) as rs>
        <#assign parentPath = "/" + item.getPSSysServiceAPI().getCodeName()?lower_case  >
        <#assign selfPath="/" + srfpluralize(itemCodeNameLC) >
        <#assign parentParams = "">
        <#assign byParams = "By">
        <#assign parentSearchParams = "" >
        <#assign parentParams2 = "">
        <#assign parentParams3 = "">
        <#assign idParams = "">
        <#assign idParams2 = "">
        <#assign idParams3 = "">
        <#assign etParams = "">
        <#assign etParamsList = "">
        <#assign etParams2 = "">
        <#assign etParams3 = "">
        <#assign id_etParams = "">
        <#assign id_etParams4 = "">
        <#assign id_etParams4_batch = "">

        <#assign rsMainDEServiceAPI = rs.getMajorPSDEServiceAPI()>
        <#assign rsMainDe = rsMainDEServiceAPI.getPSDataEntity()>
        <#assign rsMainDeCN = rsMainDe.codeName >
        <#assign rsMainDeCNLC = rsMainDeCN?lower_case >
        <#assign rsMainDePKCN = rsMainDe.getKeyPSDEField().codeName >
        <#assign rsMainDePKCNLC = rsMainDePKCN?lower_case >
        <#assign rsMainDePKDataType = rsMainDe.getKeyPSDEField().getStdDataType() >
        <#assign parentPath += "/" + srfpluralize(rsMainDEServiceAPI.codeName)?lower_case + "/{" + rsMainDeCNLC + keyCNLC + "}" >
        <#if x != 0>
          <#assign parentParams += ", ">
        </#if>
        <#assign parentParams += "@PathVariable(\"" + rsMainDeCNLC + keyCNLC + "\") " + srfjavatype(rsMainDePKDataType) +  " " + rsMainDeCNLC + keyCNLC >
        <#assign byParams += rsMainDeCN >
        <#if rs.getPSDER1N()??>
          <#assign parentSearchParams += "context.setN_" + rs.getPSDER1N().getPSPickupDEField().getCodeName()?lower_case + "_eq("+ rsMainDeCNLC + keyCNLC +");" >
        </#if>
        <#assign parentParams2 += "" + srfjavatype(rsMainDePKDataType)+" " + rsMainDeCNLC + keyCNLC >
        <#assign parentParams3 += "" + rsMainDeCNLC + keyCNLC >

        <#if parentParams != "" >
          <#assign idParams = parentParams + ", ">
          <#assign idParams2 = parentParams2 + ", ">
          <#assign idParams3 = parentParams3 + ", ">
          <#assign etParams = parentParams + ", ">
          <#assign etParamsList = parentParams + ", ">
          <#assign etParams2 = parentParams2 + ", ">
          <#assign etParams3 = parentParams3 + ", ">
          <#assign id_etParams = parentParams + ", ">
          <#assign id_etParams4 = parentParams + ", ">
          <#assign id_etParams4_batch = parentParams + ", ">
        </#if>
        <#assign etParams = etParams + "@RequestBody " + itemCodeName + "DTO " + itemCodeNameLC + "dto">
        <#assign etParamsList = etParamsList + "@RequestBody List<" + itemCodeName + "DTO> " + itemCodeNameLC + "dtos">
        <#assign etParams2 = etParams2 +  itemCodeName + "DTO " + itemCodeNameLC + "dto">
        <#assign etParams3 = etParams3 +  itemCodeNameLC + "dto">
        <#assign idParams = idParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().getStdDataType()) + " " + itemCodeNameLC + keyCNLC >
        <#assign idParams2 = idParams2 + " " + srfjavatype(de.getKeyPSDEField().getStdDataType()) + " " + itemCodeNameLC + keyCNLC >
        <#assign idParams3 = idParams3 + " " + itemCodeNameLC + keyCNLC >
        <#assign id_etParams = id_etParams + "@PathVariable(\"" + itemCodeNameLC + keyCNLC + "\") " + srfjavatype(de.getKeyPSDEField().getStdDataType())+" " + itemCodeNameLC + keyCNLC + ", @RequestBody " + itemCodeName + "DTO " + itemCodeNameLC + "dto" >
        <#assign id_etParams4 = id_etParams4 + "@RequestBody " + itemCodeName + "DTO " + itemCodeNameLC + "dto" >
        <#assign id_etParams4_batch = id_etParams4_batch + "@RequestBody List<" + itemCodeName + "DTO> " + itemCodeNameLC + "dtos" >
        <#assign fullPath = parentPath + selfPath>

        <#if item.getPSDEServiceAPIMethods()??>
        <#list item.getPSDEServiceAPIMethods() as apiMethod>
            <#assign reqMtd = apiMethod.getRequestMethod()>
            <#assign statusCode = "">
            <#if reqMtd == "POST" >
                <#assign statusCode = "HttpStatus.CREATED" >
            <#else>
                <#assign statusCode = "HttpStatus.OK" >
            </#if>
            <#if apiMethod.getActionType()=='DEACTION'>
                <#assign deaction = apiMethod.getPSDEAction()>
                <#assign deactionName = deaction.getName()>
                <#assign deactionCodeName = deaction.getCodeName()>
                <#if deaction.codeName == 'Create'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.POST, value = "${fullPath}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}${byParams}(${etParams}) {
        ${itemCodeName}DTO dto = new ${itemCodeName}DTO();
        ${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
		${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain);
        dto.fromDO(domain);
                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                            <#if apider.getMinorPSDEServiceAPI().isNested()>
                                <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
		List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
        List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
        if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
            for (${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                ${deapide.getCodeName()?lower_case}Do.set${dePKCodeName?cap_first}(dto.get${dePKCodeName?cap_first}());
                ${deapide.getCodeName()?lower_case}Service.${srfmethodname(deactionCodeName)}(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
            }
        } else {
            ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
        }
        dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);

                            </#if>
                        </#list>
                    </#if>
		return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

                <#elseif deaction.codeName == 'Update'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.PUT, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}${byParams}(${id_etParams}) {
		${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
        domain.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});
		${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain);
		${itemCodeName}DTO dto = new ${itemCodeName}DTO();
		dto.fromDO(domain);
                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deMinApi = apider.getMinorPSDEServiceAPI()>
                            <#assign deMinApiCN = deMinApi.getCodeName()>
                            <#assign deMinApiCNLC = deMinApi.getCodeName()?lower_case>
                            <#assign deapide=deMinApi.getPSDataEntity()>
                            <#if deMinApi.isNested()>
                                <#assign subDTOs = srfpluralize(deMinApiCN)?lower_case >
		List<${deMinApiCN}DTO> ${deMinApiCNLC}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
		List<${deapide.getCodeName()}> ${deMinApiCNLC}DOs = ${deapide.getCodeName()?lower_case}Service.selectBy${apider.getPSDER1N().getCodeName()}2(${itemCodeNameLC + keyCNLC});
        List<${srfjavatype(deapide.getKeyPSDEField().getStdDataType())}> ${deMinApiCNLC}Ids = new ArrayList<${srfjavatype(deapide.getKeyPSDEField().getStdDataType())}>();
        if (${deMinApiCNLC}DOs != null && !${deMinApiCNLC}DOs.isEmpty()) {
            for (${deapide.getCodeName()} minorDO : ${deMinApiCNLC}DOs) {
                ${deMinApiCNLC}Ids.add(minorDO.get${deapide.getKeyPSDEField().getCodeName()?cap_first}());
            }
        }
        List<${deMinApiCN}DTO> ${deMinApiCNLC}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
        if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
            for (${deMinApiCN}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                ${deapide.getCodeName()?lower_case}Do.set${dePKCodeName?cap_first}(dto.get${dePKCodeName?cap_first}());
                if ( StringUtils.isEmpty( ${deapide.getCodeName()?lower_case}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}()) || (${deMinApiCNLC}Ids != null && !${deMinApiCNLC}Ids.isEmpty() &&  ${deMinApiCNLC}Ids.contains(${deapide.getCodeName()?lower_case}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}()))) {
                    ${deapide.getCodeName()?lower_case}Service.save(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
                } else {
                    ${deapide.getCodeName()?lower_case}Service.remove(${deapide.getCodeName()?lower_case}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}());
                }
            }
        } else {
            ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
        }
        dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);

                            </#if>
                        </#list>
                    </#if>
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

                <#elseif deaction.codeName == 'Get'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.GET, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}${byParams}(${idParams}) {
        ${itemCodeName}DTO dto = new ${itemCodeName}DTO();
        ${deCodeName} domain =new ${deCodeName}();
        domain.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});
		${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain);
		dto.fromDO(domain);
                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                            <#if apider.getMinorPSDEServiceAPI().isNested()>
                                <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
        Page<${deapide.getCodeName()}> ${deapide.getCodeName()?lower_case?cap_first}Dos = ${deapide.getCodeName()?lower_case}Service.selectBy${apider.getPSDER1N().getCodeName()}(${itemCodeNameLC + keyCNLC});
		if(${deapide.getCodeName()?lower_case?cap_first}Dos != null){
		    List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subDTOs} = new ArrayList<${deapide.getCodeName()}DTO>();
            for (${deapide.getCodeName()} ${deapide.getCodeName()?lower_case?cap_first}Do : ${deapide.getCodeName()?lower_case?cap_first}Dos) {
                ${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dto = new ${apider.getMinorPSDEServiceAPI().getCodeName()}DTO();
                ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case?cap_first}Do);
                ${subDTOs}.add(${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dto);
            }
            dto.set${subDTOs?cap_first}(${subDTOs});
        }
                            </#if>
                        </#list>
                    </#if>
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

                <#elseif deaction.codeName == 'Remove'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.DELETE, value = "${fullPath}/{${itemCodeNameLC + keyCNLC}}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${idParams}) {
        ${itemCodeName}DTO ${itemCodeNameLC}dto = new ${itemCodeName}DTO();
		${deCodeName} domain = new ${deCodeName}();
		${itemCodeNameLC}dto.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});
		domain.set${dePKCodeName?cap_first}(${itemCodeNameLC + keyCNLC});

                    <#if item.getPSDEServiceAPIRSs()??>
                        <#list item.getPSDEServiceAPIRSs() as apider>
                            <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                            <#if apider.getMinorPSDEServiceAPI().isNested()>
		Map<String, Object> ${deapide.getCodeName()?lower_case?cap_first}Map = new HashMap<String, Object>();
        ${deapide.getCodeName()?lower_case?cap_first}Map.put("${dePKCodeNameLC}",${itemCodeNameLC + keyCNLC});
        Page<${deapide.getCodeName()}> ${deapide.getCodeName()?lower_case?cap_first}Dos = ${deapide.getCodeName()?lower_case}Service.selectBy${apider.getPSDER1N().getCodeName()}(${itemCodeNameLC + keyCNLC});
		if(${deapide.getCodeName()?lower_case?cap_first}Dos != null){
            for (${deapide.getCodeName()} ${deapide.getCodeName()?lower_case?cap_first}Do : ${deapide.getCodeName()?lower_case?cap_first}Dos) {
                ${deapide.getCodeName()?lower_case}Service.${deactionCodeName?lower_case}(${deapide.getCodeName()?lower_case?cap_first}Do.get${deapide.getKeyPSDEField().getCodeName()?cap_first}());
            }
        }
                            </#if>
                        </#list>
                    </#if>
        Boolean rst = ${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(domain.get${dePKCodeName?cap_first}());
        if(rst){
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}else{
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}
    }

               <#elseif deaction.codeName == 'CheckKey'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParams}) {

        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

               <#elseif deaction.codeName == 'CreateBatch'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParamsList}) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

               <#elseif deaction.codeName == 'UpdateBatch'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParamsList}) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

               <#elseif deaction.codeName == 'RemoveBatch'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParamsList}) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

                <#elseif deaction.codeName == 'Save'>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
    public ResponseEntity<Boolean> ${deactionCodeName?uncap_first}${byParams}(${etParams}) {
        ${deCodeName} ${deCodeNameLC} = ${itemCodeNameLC}dto.toDO();
    	Boolean b = ${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(${deCodeNameLC}) ;
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

                <#elseif deaction.getUserTag()?? && deaction.getActionType()?? && deaction.getUserTag() == 'REGIST' && deaction.getActionType() == 'USERCREATE'>
                <#--      注册服务      -->
                    <#if deaction.isBatchAction()>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<List<${itemCodeName}DTO>> ${deactionCodeName?uncap_first}${byParams}(${id_etParams4_batch}) {
        if (${itemCodeNameLC}dtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<${deCodeName}DTO> ${itemCodeNameLC}dtos2 = new ArrayList<${deCodeName}DTO>();
        for (${itemCodeName}DTO ${itemCodeNameLC}dto : ${itemCodeNameLC}dtos) {
            ${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
            ${deCodeNameLC}Service.save(domain);
            ${itemCodeNameLC}dto.fromDO(domain);
                            <#if item.getPSDEServiceAPIRSs()??>
                                <#list item.getPSDEServiceAPIRSs() as apider>
                                    <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                                    <#if apider.getMinorPSDEServiceAPI().isNested()>
                                        <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
            List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
            List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
            if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
                for (${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                    ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                    ${deapide.getCodeName()?lower_case}Service.save(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                    ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
                }
            } else {
                ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
            }
            ${itemCodeNameLC}dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);
                                </#if>
                            </#list>
                        </#if>
            ${itemCodeNameLC}dtos2.add(${itemCodeNameLC}dto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(${itemCodeNameLC}dtos2);
    }

                    <#else>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/${deactionCodeName?lower_case}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}${byParams}(${id_etParams4}) {
        ${deCodeName} domain = ${itemCodeNameLC}dto.toDO();
		${deCodeNameLC}Service.save(domain);
        ${itemCodeNameLC}dto.fromDO(domain);
                        <#if item.getPSDEServiceAPIRSs()??>
                            <#list item.getPSDEServiceAPIRSs() as apider>
                                <#assign deapide=apider.getMinorPSDEServiceAPI().getPSDataEntity()>
                                <#if apider.getMinorPSDEServiceAPI().isNested()>
                                    <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
		List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos = ${itemCodeNameLC}dto.get${subDTOs?cap_first}();
        List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${apider.getMinorPSDEServiceAPI().getCodeName()?lower_case}dtos2 = new ArrayList<${deapide.getCodeName()}DTO>();
        if (${deapide.getCodeName()?lower_case}dtos != null && ${deapide.getCodeName()?lower_case}dtos.size() > 0) {
            for (${apider.getMinorPSDEServiceAPI().getCodeName()}DTO ${deapide.getCodeName()?lower_case}dto : ${deapide.getCodeName()?lower_case}dtos) {
                ${deapide.getCodeName()} ${deapide.getCodeName()?lower_case}Do = ${deapide.getCodeName()?lower_case}dto.toDO();
                ${deapide.getCodeName()?lower_case}Service.save(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dto.fromDO(${deapide.getCodeName()?lower_case}Do);
                ${deapide.getCodeName()?lower_case}dtos2.add(${deapide.getCodeName()?lower_case}dto);
            }
        } else {
            ${deapide.getCodeName()?lower_case}dtos2 = ${deapide.getCodeName()?lower_case}dtos;
        }
        ${itemCodeNameLC}dto.set${subDTOs?cap_first}(${deapide.getCodeName()?lower_case}dtos2);
                                </#if>
                            </#list>
                        </#if>
		return ResponseEntity.status(HttpStatus.OK).body(${itemCodeNameLC}dto);
    }

                    </#if>
                <#else>
    @ApiOperation(value = "${deaction.getLogicName()}", tags = {"${itemCodeName}" },  notes = "${deaction.getLogicName()}")
	@RequestMapping(method = RequestMethod.${reqMtd}, value = "${fullPath}/{${itemCodeNameLC + dePKCodeNameLC}}/${deactionCodeName?lower_case}")
<#if de.getStorageMode()==4><#else>    @Transactional</#if>
    public ResponseEntity<${itemCodeName}DTO> ${deactionCodeName?uncap_first}${byParams}(${id_etParams}) {
        ${deCodeName} ${deCodeNameLC} = ${itemCodeNameLC}dto.toDO();
    	${deCodeNameLC} = ${deCodeNameLC}Service.${srfmethodname(deactionCodeName)}(${deCodeNameLC}) ;
    	${itemCodeNameLC}dto.fromDO(${deCodeNameLC});
        return ResponseEntity.status(HttpStatus.OK).body(${itemCodeNameLC}dto);
    }

                </#if>
            <#elseif apiMethod.getActionType()=='FETCH'>
                <#assign deds = apiMethod.getPSDEDataSet()>
	@ApiOperation(value = "获取${deds.getLogicName()}", tags = {"${itemCodeName}" } ,notes = "获取${deds.getLogicName()}")
    @RequestMapping(method= RequestMethod.${reqMtd} , value="${fullPath}/fetch<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()?lower_case}<#else>${deds.getCodeName()?lower_case}</#if>")
	public ResponseEntity<Page<${itemCodeName}DTO>> fetch${itemCodeName}<#if (deds.getName()=='DEFAULT')>${deds.getCodeName()}<#else>${deds.getCodeName()}${byParams}</#if>(<#if parentParams!="">${parentParams},</#if>${deCodeName}SearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<${itemCodeName}DTO> list = new ArrayList<${itemCodeName}DTO>();
        ${parentSearchParams}
        Page<${deCodeName}> domains = ${deCodeNameLC}Service.search${deds.getCodeName()}(context) ;
        for(${deCodeName} ${deCodeName?lower_case} : domains.getContent()){
            ${itemCodeName}DTO dto = new ${itemCodeName}DTO();
            dto.fromDO(${deCodeName?lower_case});
            list.add(dto);
        }
	    return ResponseEntity.status(${statusCode}).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}

            </#if>
        </#list>
    </#if>
      </#list>
    </#if>
  </#list>
</#if>
<#--  关系接口  end  -->

}
</#if>
